using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Syncfusion.Web.UI.WebControls.Grid.Grouping.Common;
using Syncfusion.Web.UI.WebControls.Shared;
using Syncfusion.Grouping;
using Syncfusion.Web.UI.WebControls.Grid.Grouping;
public partial class TestArrayBinding : System.Web.UI.Page
{
    ArrayList val = new ArrayList();
protected void Page_Load(object sender, EventArgs e)
    {
       
        if (!IsPostBack)
        {
            ArrayList array = new ArrayList();
            array.Add(new MyClass(001, "John David", "UK"));
            array.Add(new MyClass(002, "Tom", "USA"));
            array.Add(new MyClass(003, "Bretney", "USA"));
            array.Add(new MyClass(004, "Jessy", "UK"));
            array.Add(new MyClass(005, "Bruch", "USA"));
            array.Add(new MyClass(006, "Johny", "USA"));
            this.GridGroupingControl1.DataSource = array;
            this.GridGroupingControl1.AutoFormat = "Office 2003 Silver";
            this.GridGroupingControl1.DataSourceCachingMode=DataSourceCachingMode.ViewState;
          
        }
        if (!CheckBox1.Checked)
            ScriptManager1.RegisterPostBackControl(GridGroupingControl1);

      
       
    }

protected string GetValue(GridCell container)
{
    string val;
    Record rowRecord = container.Row.Record;
    val = rowRecord.GetValue("City").ToString();
    return val;
}
    [Serializable]
    public class MyClass
    {
        int id;
        string name;
        string city;
        public MyClass(int id, string name, string city)
        {
            this.ID = id;
            this.Name = name;
            this.City = city;
        }

        public int ID
        {
            get { return id; }
            set { id = value; }
        }

        public string Name
        {
            get { return name; }
            set { name = value; }
        }
        public string City
        {
            get { return city; }
            set { city = value; }
        }
    }
    protected void GridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
    {
        //Look for the RecordField and AlternateField Cell.
        if (e.TableCellIdentity.TableCellType == GridTableCellType.RecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.AlternateRecordFieldCell)
        {
            //Look for the Column Name "Column2" in the GridGroupingControl when it get rendered
            if (e.TableCellIdentity.Column.Name == "City")
            {
                System.Web.UI.WebControls.Label lbl = new Label();
                lbl.ID = "Label1";
                lbl.Init += new EventHandler(lbl_Init);
                System.Web.UI.WebControls.Button btn = new Button();
                btn.ID = "Button1";
                btn.Text = "Click";
                //Here we adding the DropDownListBox programatically using ITemplate Interface
                TemplateClass mytemp = new TemplateClass(lbl,btn);
                e.TableCellIdentity.Column.ItemTemplate = mytemp;
                
            }

        }
    }
    

    void lbl_Init(object sender, EventArgs e)
    {
        //throw new NotImplementedException();
        Label lbl = (Label)sender;
        GridRow gridrow = (GridRow)lbl.Parent.Parent.Parent;
        string city = gridrow.Record.GetValue("City").ToString();
        lbl.Text = city;
        string uid = gridrow.UniqueID;
        string[] rposition = uid.Split(new char[] { '^' });
        string[] rowpos = rposition[1].Split(new char[] { '*' });
        int rowid = Convert.ToInt32(rowpos[0]);
        if (rowid % 2 == 0)
        {
            val.Add(lbl.Text);
        }

    }

    public class TemplateClass : ITemplate
    {
        private Control m_ctrlChildControl1 = null;
        private Control m_ctrlChildControl2 = null;
        public TemplateClass(Control ctrlChildControl1, Control ctrlChildControl2)
        {
            m_ctrlChildControl1 = ctrlChildControl1;
            m_ctrlChildControl2 = ctrlChildControl2;
        }

        public void InstantiateIn(Control container)
        {
            container.Controls.Add(m_ctrlChildControl1);
            container.Controls.Add(m_ctrlChildControl2);
        }
    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        int cnt = val.Count;
    }
}
