<%@ Page Language="C#" AutoEventWireup="true" CodeFile="ArrayListBinding.aspx.cs"
    Inherits="TestArrayBinding" %>

<%@ Register Assembly="Syncfusion.Grid.Grouping.Web, Version=6.303.1.9, Culture=neutral, PublicKeyToken=3D67ED1F87D44C89"
    Namespace="Syncfusion.Web.UI.WebControls.Grid.Grouping" TagPrefix="sfwg" %>
<%@ Register Assembly="Syncfusion.Shared.Web, Version=6.303.1.9, Culture=neutral, PublicKeyToken=3D67ED1F87D44C89"
    Namespace="Syncfusion.Web.UI.WebControls.Shared" TagPrefix="ssw" %>
<%@ Register Assembly="Syncfusion.Shared.Base, Version=6.303.1.9, Culture=neutral, PublicKeyToken=3D67ED1F87D44C89"
    Namespace="Syncfusion.Styles" TagPrefix="cc1" %>
<%@ Register Assembly="Syncfusion.Grid.Windows, Version=6.303.1.9, Culture=neutral, PublicKeyToken=3D67ED1F87D44C89"
    Namespace="Syncfusion.Windows.Forms.Grid" TagPrefix="cc2" %>
<%@ Register Assembly="Syncfusion.Grouping.Base, Version=6.303.1.9, Culture=neutral, PublicKeyToken=3D67ED1F87D44C89"
    Namespace="Syncfusion.Grouping" TagPrefix="cc3" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Essential Grid with ArrayList</title>
</head>
<body>
    <form id="form1" runat="server">
        <div>
            <h4>
                Essential Grid with ArrayList</h4>
            <hr>
            <br />
            <asp:ScriptManager ID="ScriptManager1" runat="server" />

            <script type="text/javascript">
                Sys.WebForms.PageRequestManager.getInstance().add_beginRequest(BeginRequestHandler);
                Sys.WebForms.PageRequestManager.getInstance().add_endRequest(EndRequestHandler);
                function BeginRequestHandler(sender, args)
                {
                    Popup.ShowPopup();                    
                }
                function EndRequestHandler(sender, args)
                {
                     Popup.HidePopup();     
                }
            </script>

            <asp:CheckBox ID="CheckBox1" runat="server" Checked="true" AutoPostBack="true" Text="Enable ASP.NET AJAX Callback" />
            <br /> <table id="GridTable">
                        <tr>
                            <td>
            <asp:UpdatePanel ID="GridPanel" runat="server" UpdateMode="Conditional">
                <ContentTemplate>
                   
                                <sfwg:GridGroupingControl EnableCallbacks="false" ID="GridGroupingControl1" runat="server"
                                    Width="200" onquerycellstyleinfo="GridGroupingControl1_QueryCellStyleInfo">
                                    <TableDescriptor AllowNew="False">
                                      <Columns>
                                    <sfwg:GridColumnDescriptor MappingName="ID"></sfwg:GridColumnDescriptor>
                                    
                                    <sfwg:GridColumnDescriptor MappingName="City">
                                  <%--  <ItemTemplate>
                                    
                                        <asp:Label ID="Label1" runat="server" Text="<%#GetValue(Container)%>"></asp:Label> 
                                 
                                        <asp:Button ID="Button1" runat="server" Text="Click" />
                                    
                                    
                                    </ItemTemplate>--%>
                                    </sfwg:GridColumnDescriptor>
                                     <sfwg:GridColumnDescriptor MappingName="Name"></sfwg:GridColumnDescriptor>
                                    </Columns>
                                    </TableDescriptor>
                                </sfwg:GridGroupingControl>
                            
                </ContentTemplate>
                <Triggers>
                    <asp:AsyncPostBackTrigger ControlID="CheckBox1" />
                </Triggers>
            </asp:UpdatePanel></td>
                        </tr>
                    </table>
            <ssw:WaitingPopup DisableOnShowElementID="GridTable" ID="WaitingPopup1"
                ClientObjectId="Popup" runat="server" Alignment="MiddleCentre" AutoFormat="BlueDots"
                Height="50px" Width="125px" DisabledBackgroundColor="221, 227, 238">
                <br />
            </ssw:WaitingPopup>
            <%--<asp:GridView ID="GridView1" runat="server" AutoGenerateEditButton="True" 
            AutoGenerateColumns="False" DataKeyNames="DEPTNO" 
            DataSourceID="AccessDataSource1">
            <Columns>
                <asp:BoundField DataField="ID" HeaderText="ID" SortExpression="ID" />
                <asp:BoundField DataField="DEPTNO" HeaderText="DEPTNO" ReadOnly="True" 
                    SortExpression="DEPTNO" />
                <asp:BoundField DataField="DEPTNAME" HeaderText="DEPTNAME" 
                    SortExpression="DEPTNAME" />
            </Columns>
        </asp:GridView>
        <asp:AccessDataSource ID="AccessDataSource1" runat="server" 
            DataFile="~/App_Data/department.mdb" 
            DeleteCommand="DELETE FROM [dept] WHERE [DEPTNO] = ?" 
            InsertCommand="INSERT INTO [dept] ([ID], [DEPTNO], [DEPTNAME]) VALUES (?, ?, ?)" 
            SelectCommand="SELECT [ID], [DEPTNO], [DEPTNAME] FROM [dept]" 
            UpdateCommand="UPDATE [dept] SET [ID] = ?, [DEPTNAME] = ? WHERE [DEPTNO] = ?">
            <DeleteParameters>
                <asp:Parameter Name="DEPTNO" Type="String" />
            </DeleteParameters>
            <UpdateParameters>
                <asp:Parameter Name="ID" Type="Int32" />
                <asp:Parameter Name="DEPTNAME" Type="String" />
                <asp:Parameter Name="DEPTNO" Type="String" />
            </UpdateParameters>
            <InsertParameters>
                <asp:Parameter Name="ID" Type="Int32" />
                <asp:Parameter Name="DEPTNO" Type="String" />
                <asp:Parameter Name="DEPTNAME" Type="String" />
            </InsertParameters>
        </asp:AccessDataSource>--%>
        </div>
        <asp:Button ID="Button1" runat="server" onclick="Button1_Click" Text="Button" />
    </form>
</body>
</html>

